%{
#include <stdlib.h>
#include <stdio.h>
extern int yylex();
extern int yyparse();
void yyerror(const char *s);
%}
%start JValue
%token T_STRING T_NUMBER T_TRUE T_FALSE T_NULL
%%
JValue: T_STRING {puts("String");}
      | T_NUMBER {puts("Number");}
      | T_TRUE   {puts("TRUE");}
      | T_FALSE  {puts("FALSE");}
      | T_NULL   {puts("NULL");}
      | JArray   {puts("Array");}
      | JObject  {puts("Object");}

JArray: '[' ']'
      | '[' Liste ']'

Liste: JValue
     | JValue ',' Liste

JObject: '{' '}'
       | '{' KVListe '}'

KVListe: KV
       | KVListe ',' KV
KV: T_STRING ':' JValue
%%

int main(void) {
	yyparse();
	return 0;
}

void yyerror(const char *s) {
	printf("Parse error: %s\n",s);
	exit(-1);
}
